---
title: USBDevice.clearHalt()
slug: Web/API/USBDevice/clearHalt
tags:
  - API
  - Method
  - Reference
  - USB
  - USBDevice
  - WebUSB
  - WebUSB API
  - clearHalt
---
<p>{{APIRef("WebUSB API")}}{{SeeCompatTable}}</p>

<p>The <strong><code>clearHalt()</code></strong> method of the {{domxref("USBDevice")}} interface returns a {{jsxref("promise")}} that resolves when a halt condition is cleared. A halt condition is when a data tranfer to or from the device has a status of <code>'stall'</code>, which requires the web page (the <em>host</em> system, in USB terminology) to clear that condition. See the for details.</p>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var promise = USBDevice.clearHalt(<em>direction</em>, <em>endpointNumber</em>)</pre>

<h3 id="Parameters">Parameters</h3>

<dl>
 <dt>direction</dt>
 <dd>Indicates whether the devices input or output should be cleared. Valid values are <code>'in'</code> or <code>'out'</code>.</dd>
 <dt>endpointNumber</dt>
 <dd>Indicates the number of the endpoint to clear. The promise will reject if an invalid endpoint is supplied.</dd>
</dl>

<h3 id="Return_value">Return value</h3>

<p>A {{jsxref("promise")}}.</p>

<h2 id="Example">Example</h2>

<p>The following example shows how to test for and clear a <code>'stall'</code> condition in the result of a data transfer.  </p>

<div class="note">
<p>What data can be passed to a USB device and how it is passed is particular and unique to each device. </p>
</div>

<pre class="brush: js">while (true) {
  let result = await data.transferIn(1, 6);

  if (result.data &amp;&amp; result.data.byteLength === 6) {
    console.log('Channel 1: ' + result.data.getUint16(0));
    console.log('Channel 2: ' + result.data.getUint16(2));
    console.log('Channel 5: ' + result.data.getUint16(4));
  }

  if (result.status === 'stall') {
    console.warn('Endpoint stalled. Clearing.');
    await device.clearHalt('in', 1);
  }
}
</pre>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <tbody>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
  <tr>
   <td>{{SpecName('Web USB','#dom-usbdevice-clearhalt','clearHalt()')}}</td>
   <td>{{Spec2('Web USB')}}</td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.USBDevice.clearHalt")}}</p>
